Name:          truezip
Version:       7.7.9
Release:       3%{?dist}
Summary:       Java based VFS for treating archive files as virtual directories

License:       EPL
URL:           http://truezip.java.net/

# hg clone https://hg.java.net/hg/truezip~v7 && cd truezip~v7/
# hg archive -r truezip-7.7.9 truezip-7.7.9.tar.gz -X ".hg*"
Source0:       %{name}-%{version}.tar.gz
Source1:       http://www.eclipse.org/legal/epl-v10.html

BuildArch:     noarch
BuildRequires: maven-local
BuildRequires: mvn(com.google.code.findbugs:annotations)
BuildRequires: mvn(junit:junit)
# Use truecommons-parent:107
BuildRequires: mvn(net.java.truecommons:truecommons-parent:pom:)
BuildRequires: mvn(org.apache.commons:commons-compress)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.maven.plugins:maven-enforcer-plugin)
BuildRequires: mvn(org.bouncycastle:bcprov-jdk15on)
BuildRequires: mvn(org.jsr-305:ri)
BuildRequires: mvn(org.netbeans:jemmy)
BuildRequires: mvn(org.tukaani:xz)

Requires:      %{name}-driver-parent = %{version}-%{release}
Requires:      %{name}-driver-file = %{version}-%{release}
Requires:      %{name}-driver-http = %{version}-%{release}
Requires:      %{name}-driver-tar = %{version}-%{release}
Requires:      %{name}-driver-tzp = %{version}-%{release}
Requires:      %{name}-driver-zip = %{version}-%{release}
Requires:      %{name}-extension-parent = %{version}-%{release}
Requires:      %{name}-extension-jmx-jul = %{version}-%{release}
Requires:      %{name}-extension-pace = %{version}-%{release}
Requires:      %{name}-file = %{version}-%{release}
Requires:      %{name}-kernel = %{version}-%{release}
Requires:      %{name}-path = %{version}-%{release}
Requires:      %{name}-samples = %{version}-%{release}
Requires:      %{name}-swing = %{version}-%{release}

%description
TrueVFS is a Java based virtual file system (VFS) which enables
client applications to perform CRUD (Create, Read, Update, Delete)
operations on archive files as if they were virtual directories,
even with nested archive files in multithreaded environments.

As a library, TrueVFS provides simple, uniform, transparent,
thread-safe, read/write access to archive files as if they were
virtual directories in a file system path.

As a framework, TrueVFS provides the interfaces and classes to
write file system drivers which plug-in to its federated file
system space.

%package parent
Summary:       Parent POM for TrueZip modules

%description parent
Parent POM for TrueZip modules.

%package driver-parent
Summary:       Parent POM for TrueZip pluggable file system drivers

%description driver-parent
Parent POM for TrueZip pluggable file system drivers.

%package driver-file
Summary:       TrueZip driver for the FILE scheme

%description driver-file
The file system driver family for the FILE scheme.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-http
Summary:       TrueZip driver for the HTTP(S) scheme

%description driver-http
The file system driver for the HTTP(S) scheme.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-tar
Summary:       TrueZip driver for TAR archives

%description driver-tar
The file system driver family for TAR and related archive file types.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-tzp
Summary:       TrueZip driver for ZIP.RAES (TZP) encrypted archives

%description driver-tzp
The file system driver family for RAES encrypted ZIP alias
ZIP.RAES alias TZP files.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-zip
Summary:       TrueZip driver for ZIP archives

%description driver-zip
TrueZIP Path module application - requires JSE 7.

%package extension-parent
Summary:       Parent POM for TrueZip pluggable extensions

%description extension-parent
Parent POM for TrueZip pluggable extensions.

%package extension-jmx-jul
Summary:       TrueZip JMX/JUL Extension

%description extension-jmx-jul
This module provides a file system manager and an I/O pool service
for managing and monitoring TrueZIP via JMX and java.util.logging.

Add the JAR artifact of this module to the run time class path to
make its file system manager and I/O pool service available for
service location in the client API modules.

%package extension-pace
Summary:       TrueZip PaceManager Extension

%description extension-pace
This module constrains the number of mounted archive files in order to
save some heap space. It provides a JMX interface for monitoring and
management. Add the JAR artifact of this module to the run time class
path to make its services available for service location in the client
API modules.

%package file
Summary:       TrueZip File*

%description file
This module provides the TFile* classes for simple, uniform,
transparent, thread-safe, read/write access to archive files
as if they were virtual directories in a file system path.

This module also provides Swing GUI classes for viewing file
trees and choosing entries in archive files.

%package kernel
Summary:       Implements and manages virtual file systems for %{name}


%description kernel
This module implements virtual file systems from arbitrary resources,
manages their state and commits unsynchronized changes if required or
requested.

The TrueZIP Kernel uses file system drivers to access these resources.
It provides multithreading, multiplexing, caching and buffering so that
the file system drivers do not need to take care of this.

%package path
Summary:       TrueZip Path

%description path
This module provides the TPath class for simple, uniform,
transparent, thread-safe, read/write access to archive
files as if they were virtual directories in a file system path.
It also provides the TFileSystemProvider class to implement a file
system provider for the NIO.2 API (JSR 203) in JSE 7.

%package samples
Summary:       TrueZip Samples

%description samples
Sample applications to demonstrate the usage of various TrueZIP module
APIs.

Some of these samples use rather advanced or exotic features which
makes them more complex than necessary for a typical application.

By design, the sample applications use all file system drivers which
can be located at runtime.
Location of the available file system drivers is performed by
scanning the class path - see the Javaodoc for the TrueZIP Kernel class
de.schlichtherle.truezip.fs.sl.FsDriverLocator for more information.

%package swing
Summary:       TrueZip general Swing GUI classes

%description swing
General Swing GUI classes.

This module does not depend on other TrueZIP modules.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q

find -type f -name *.zip -delete
find -type f -name *.jar -delete
find -type f -name *.class -delete

# Add jsr-305 as dependency for javax.annotation.concurrent
%pom_add_dep org.jsr-305:ri

# ${project.groupId} doesn't seem to get expanded properly here
%pom_remove_dep :%{name}-kernel %{name}-extension
%pom_add_dep de.schlichtherle.%{name}:%{name}-kernel:%{version} %{name}-extension
%pom_remove_dep :%{name}-kernel %{name}-driver
%pom_add_dep de.schlichtherle.%{name}:%{name}-kernel:%{version} %{name}-driver

find -name pom.xml -exec \
 sed -i -e "s/\${project.groupId}/de.schlichtherle.truezip/g" -e "s/\${project.version}/%{version}/g" {} \;

%pom_disable_module %{name}-archetype

%pom_remove_plugin -r :maven-assembly-plugin

cp -p %{SOURCE1} .

%build
# Skipping tests because some fail with 'Bad test setup' error
%mvn_build -s --skip-tests

%install
%mvn_install

%files parent -f .mfiles-%{name}
%files javadoc -f .mfiles-javadoc
%license epl-v10.html
%files driver-parent -f .mfiles-%{name}-driver
%files driver-file -f .mfiles-%{name}-driver-file
%files driver-http -f .mfiles-%{name}-driver-http
%files driver-tar -f .mfiles-%{name}-driver-tar
%files driver-tzp -f .mfiles-%{name}-driver-tzp
%files driver-zip -f .mfiles-%{name}-driver-zip
%files extension-parent -f .mfiles-%{name}-extension
%files extension-jmx-jul -f .mfiles-%{name}-extension-jmx-jul
%files extension-pace -f .mfiles-%{name}-extension-pace
%files file -f .mfiles-%{name}-file
%files kernel -f .mfiles-%{name}-kernel
%license epl-v10.html
%files path -f .mfiles-%{name}-path
%files samples -f .mfiles-%{name}-samples
%files swing -f .mfiles-%{name}-swing

%changelog
* Fri Apr 08 2016 gil cattaneo <puntogil@libero.it> - 7.7.9-3
- rebuilt

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 7.7.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sun Jul 19 2015 gil cattaneo <puntogil@libero.it> 7.7.9-1
- update to 7.7.9

* Sun Jul 19 2015 gil cattaneo <puntogil@libero.it> 7.7.5-7
- fix FTBFS rhbz#1240078
- fix BR list
- resolve some rpmlint problems
- use BR mvn()-like
- install license file

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.7.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.7.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Mar 13 2014 Michael Simacek <msimacek@redhat.com> - 7.7.5-4
- Drop manual requires

* Wed Feb 26 2014 Gerard Ryan <galileo@fedoraproject.org> - 7.7.5-3
- Patch to fix bouncycastle API changes

* Tue Feb 25 2014 Gerard Ryan <galileo@fedoraproject.org> - 7.7.5-1
- RHBZ#1068570: Switch to java-headless (build)requires
- RHBZ#1030946: Update to upstream version 7.7.5

* Sat Dec 28 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.7.4-10
- Rebuild with new findbugs-2.0.3

* Sat Nov 16 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.7.4-8
- Remove non-expanding POM variables
- Fix duplicated constants preventing build

* Fri Nov 08 2013 Marek Goldmann <mgoldman@redhat.com> - 7.7.4-7
- Rebuild after change in bouncycastle

* Thu Oct 24 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.7.4-6
- Use correct parent now that it's packaged
- Remove unnecessary pom_add_dep call

* Tue Oct 22 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.7.4-5
- Fix dependency problem with project.groupId variable

* Wed Oct 16 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.7.4-4
- Force version-release 21-3 of parent

* Wed Oct 16 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.7.4-2
- Fix for pom variable not expanding in dependency

* Mon Oct 14 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.7.4-1
- Update to version 7.7.4

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.6.6-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Apr 16 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.6.6-4
- Use new maven macros.

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.6.6-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 7.6.6-2
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Sat Oct 13  2012 Gerard Ryan <galileo@fedoraproject.org> - 7.6.6-1
- Update to upstream 7.6.6.
- Remove patch and add pom macros instead.
- add new PaceManager extension as a subpackage.
- Switch parent in POM to older parent from 7.5.5.

* Tue Jul 24 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-6
- Add schlichtherle-oss-parent as a requires for truezip-parent

* Tue Jul 24 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-5
- Add -parent subpackage, as main pom seems needed for maven

* Mon Jul 23 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-4
- Fix spelling errors; Add license file to srpm.

* Tue Jul 17 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-3
- Put jar files into a sub-directory of javadir
- Add -f flag to add_maven_depmap macro calls
- correctly name POM files
- Add release requirement to versioned dependencies
- Remove unnecessary group field from subpackages

* Fri Jul 13 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-2
- Add additional maven requirements to BR.

* Fri Jun 29 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-1
- Initial package.
